#include "windows.h"
//-------    PROSPICE.
#include "i8080.h" //-       .
#include "opcodes.h"
#include "opcodes_.h"
i8080::i8080()
{
	SetupEn = 0;
	CountT = 0;
	f1u = f1d = f2u = f2d = false;
}
//--- DEVICE::isdigital --------------------------------------------------------------
//---   ,  PROSPICE    
//---      . PROSPICE   IDSIMPIN  
//--- ,       ,   .
//---         IINSTANCE::getdsimpin.
//--- DSIM       DSIM.
//---         ,  ,
//---         .
//--- .    VSMSDK.HLP: Class IDSIMPIN
INT i8080::isdigital (CHAR *pinname)
{
	return 1;  //---     
	//---  :
	//---  1      .
	//---  0       .
	//--- -1     ,   ,    .
}

//--- DEVICE::setup ------------------------------------------------------------------
//---    PROSPICE   ,   
//---     .
//---          
//---   DSIM ,   .   -   ...
VOID i8080::setup (IINSTANCE *instance, IDSIMCKT *dsimckt)
{
	//------------------- IINSTANCE *instance -    ,
	//-------------------    .
	//----------------------------------------- IDSIMCKT *ckt -   DSIM ,
	//-----------------------------------------     .

	//--- ,       .
	inst = instance;
//	LogicInst.inst = inst;
//	i8080A.inst = inst;
	ckt = dsimckt;
//	LogicInst.ckt = ckt;
	SetupEn = 1;

	//---       IINSTANCE::getdsimpin, 
	//---    ,     .
	//---       
	PinC1 = inst->getdsimpin("C1", true); //--- Pin1    "D"
	PinC2 = inst->getdsimpin("C2", true); //--- Pin2    "C"
	PinRDY = inst->getdsimpin("RDY", true); //--- Pin1    "D"
	PinHLT = inst->getdsimpin("HLT", true);
	PinINT = inst->getdsimpin("INT", true); //--- Pin2    "C"
	PinR = inst->getdsimpin("$R$", true);
	PinBUSA = inst->getbuspin("A", 0, 16, true); //--- Pin3    "Q"
	PinBUSD = inst->getbuspin("D", 0, 8, true); //--- Pin3    "Q"
	PinWAIT = inst->getdsimpin("WAIT", true);
	PinHLDA = inst->getdsimpin("HLDA", true);
	PinINTE = inst->getdsimpin("INTE", true);
	PinDBIN = inst->getdsimpin("DBIN", true);
	PinWR = inst->getdsimpin("$WR$", true);
	PinSYNC = inst->getdsimpin("SYNC", true);
	CCycles = 0;

	//---     :
	PinBUSA->drivetristate(0);
//	PinBUSA->drivebusvalue(0, 0x00);
	PinSYNC->drivebool(0, 0);
//	PinBUSD->drivebusvalue(0, 0xA5);

//	ckt->setcallback(0, this, 0x00);
	cpureset(0);
	c1 = 0;
	c2 = 0;
/*	FrontC10.m_bStateOld = 0;
	FrontC11.m_bStateOld = 0;
	FrontC20.m_bStateOld = 0;
	FrontC21.m_bStateOld = 0;
*/
	PinDBIN->drivebool(0, 0);
	PinWR->drivebool(0, 1);
	PinHLDA->drivebool(0, 1);
	PinWAIT->drivebool(0, 0);
	PinINTE->drivebool(0, 1);

	f1o = 0;
	f2o = 0;

	CPUs.height = 14;
	CPUs.width = 30;
	CPUs.caption = "CPU";
	CPUs.type = PWT_STATUS;
	CPUs.id = 666;
	CPUs.flags = PWF_AUTOREFRESH;
	pCPU = (ICPU *)inst->createpopup(&CPUs);
	inst->setvdmhlr(pCPU);

	vm80a.pin_clk = 0;       // global module clock (no in original 8080)
	vm80a.pin_f1 = 0;        // clock phase 1 (used as clock enable)
	vm80a.pin_f2 = 0;        // clock phase 2 (used as clock enable)
	vm80a.pin_reset = 0;     // module reset
	vm80a.pin_a = &pin_a;         // address bus /*output*/s
	vm80a.pin_dout = &pin_dout;      // data bus /*output*/
	vm80a.pin_din = 0;       // data bus /= input= /
	vm80a.pin_aena = &pin_aena;      // address /= output= /s enable
	vm80a.pin_dena = &pin_dena;      // data /= output= /s enable
	vm80a.pin_hold = 0;      //
	vm80a.pin_hlda = &pin_hlda;      //
	vm80a.pin_ready = 0;     //
	vm80a.pin_wait = &pin_wait;      //
	vm80a.pin_int = 0;       //
	vm80a.pin_inte = &pin_inte;      //
	vm80a.pin_sync = &pin_sync;      //
	vm80a.pin_dbin = &pin_dbin;      //
	vm80a.pin_wr_n = &pin_wr_n;

//	pIDSIMCKT
/*
	IVARPOPUPs.height = 14;
	IVARPOPUPs.width = 30;
	IVARPOPUPs.caption = "VAR";
	IVARPOPUPs.type = PWT_STATUS;
	IVARPOPUPs.id = 777;
	IVARPOPUPs.flags = PWF_VISIBLE||PWF_AUTOREFRESH;
	pIVARPOPUP = (IVARPOPUP*)inst->createpopup(&IVARPOPUPs);

	ISOURCEPOPUPs.height = 14;
	ISOURCEPOPUPs.width = 30;
	ISOURCEPOPUPs.caption = "SOURCE";
	ISOURCEPOPUPs.type = PWT_STATUS;
	ISOURCEPOPUPs.id = 999;
	ISOURCEPOPUPs.flags = PWF_VISIBLE||PWF_AUTOREFRESH;
	pISOURCEPOPUP = (ISOURCEPOPUP *)inst->createpopup(&ISOURCEPOPUPs);
*/
//	varitem.
//	pCPU->getvardata(&varitem, &vardata);
//	pCPU->disassemble(0, 1);
//	BYTE data;
//	pCPU->loaddata(0, 0, 0, &data, 1);
//	pCPU->vdmhlr(&vdm_command, &data);

//	ivarpopup.setcpu(&CPU);
//	ivarpopup.additem(&varitem);

//	uAF.AR[1]
	//---    : (.VSMSDK State Type)
	//---  Floating    FLT    Floating output - high-impedance.
	//---  Power High   PHI   Logic 1 power rail.
	//---  Power Low   PLO   Logic 0 power rail.   

//    Debug-log :
/*  CREATEPOPUPSTRUCT *cps = new CREATEPOPUPSTRUCT;
  cps->caption = "CPU Debug Log"; //  
  cps->flags = PWF_VISIBLE;       //  
  cps->type = PWT_DEBUG;          //   - DEBUG
  cps->height = 500;              //  
  cps->width = 300;               //  
  cps->id = 123;                  //  

  dbPopup = (IDEBUGPOPUP *)instance->createpopup(cps);*/
//   -:    IDEBUGPOPUP *dbPopup;
}

//---- DEVICE::runctrl ------------------------------------------------------------------
//----    PROSPICE        
//---- .      ,     
//----    ,      .
//----           
//----    (breakpoints).
//----         
//----   ,        .   
//----         , 
//----     .
//----
VOID i8080::runctrl (RUNMODES mode)
{
	//---     (RUNMODES mode):
	//---    RM_BATCH=-1,      // BATCH-    ;
	//---    RM_START,          //     () .
	//---    RM_STOP,         //   (  )
	//---    RM_SUSPEND,      //   (  );
	//---    RM_ANIMATE,      //   ;
	//---       :
	//---    RM_STEPTIME,      //  STEP()  
	//---    RM_STEPOVER,      //  "  "(Step Over command)
	//---    RM_STEPINTO,      //  "  " (Step Into command)
	//---    RM_STEPOUT,      //  "  "(Step Out command)
	//---    RM_STEPTO          //  "  "(Step To command)
	//---    ,     CPU  . 

	//---    VOID IINSTANCE::log (CHAR *msg, ...)  .
	//---     log- .
	//---           log-
	//---    ,         .
	//---   "printf"  C     [ ... ].
	//--- :
	//--- if (instance) instance->log ("DIGONLY::runctrl() called with mode=%d:%s", mode, EnumToRunCtrl(mode));

	//---         :
	//--- BOOL IINSTANCE::message (CHAR *msg, ...) -      ISIS.
	//---        .
	//---    "printf"  C     [ ... ].

	//---   , ,    ,  
	//---    log,    . (. Logging and messaging: )

	if(!SetupEn)
		return;

	static int dlg = 0;
	if (mode == RM_SUSPEND)
	{
		RegPrint();
		dlg = 1;
	}
	else
	{
		if(dlg)
		{
			inst->deletepopup(888);
		}
	}

	if(mode == RM_ANIMATE)
	{
		if(SetupEn == 1)
		{
			SetupEn++;
		}
	}
	
	if(mode == RM_STEPTIME)
	{
//		ckt->suspend(inst, "");
		inst->log("mode: %d RM_STEPTIME", mode);
	}

	if(mode == RM_STEPTIME)
	{
		inst->log("mode: %d RM_STEPTIME", mode);
	}
	if(mode == RM_STEPOVER)
	{
		inst->log("mode: %d RM_STEPOVER", mode);
	}
	if(mode == RM_STEPINTO)
	{
		inst->log("mode: %d RM_STEPINTO", mode);
	}
	if(mode == RM_STEPOUT)
	{
		inst->log("mode: %d RM_STEPOUT", mode);
	}
	if(mode == RM_STEPTO)
	{
		inst->log("mode: %d RM_STEPTO", mode);
	}
	Mode = mode;
	vm80a.cycle();

}

//---- DEVICE::actuate ------------------------------------------------------------------
//----    PROSPICE      
//----   ,   .. (  ).
//----           
//----      ,  
//----       .
VOID i8080::actuate (REALTIME time, ACTIVESTATE newstate)
{
	//----   (ACTIVESTATE newstate)
	inst->log("actuate");

}

//---- DEVICE::indicate ------------------------------------------------------------------
//----    PROSPICE     .  
//----          
//----     .
//----
BOOL i8080::indicate (REALTIME time, ACTIVEDATA *data)
{
	//----   (ACTIVEDATA *data)
	//----        (.VSMSDK.HLP).
	return FALSE;
}

//---- DEVICE::simulate ------------------------------------------------------------------
//----    DSIM         
//----      .
//----           ,
//----   IDSIMPIN      IDSIMPIN::setstate, 
//----       .
//----     ,    
//---- ,   IDSIMCKT::setcallback.
//----   (DSIMMODES = BOOT,     .   
//----    "simulate"   .)
VOID i8080::simulate (ABSTIME time, DSIMMODES mode)
{
	//---         (istate()),
	//---        (setstate()):
	//  Pin3->setstate(time, 1, Pin1->istate());
	//  Pin4->setstate(time, 1, Pin2->istate());
	//---      Pin1  Pin2,   1 "" 
	//---(1 )    (time)  
	//---       Pin3  Pin4.
	//---       , ,  
	//---    .  ,   
	//---   .   ,     
	//---   .
//	PinBUSA->drivebusvalue(time, PinBUSD->getbusvalue());//   
//  1 2
//	inst->log("simulate mode: %d time: %d", mode, time);
	f1 = ishigh(PinC1->istate());
	f1u = !f1o && f1;
	f1d = f1o && !f1;
	f1o = f1;

	f2 = ishigh(PinC2->istate());
	f2u = !f2o && f2;
	f2d = f2o && !f2;
	f2o = f2;

	RDY = ishigh(PinRDY->istate());
	HLT = ishigh(PinHLT->istate());
	INT = ishigh(PinINT->istate());
	RES = ishigh(PinR->istate());

	Time = time;
	if(Mode == 6)
		ckt->suspend(inst, "stepinto");

	Simulate(time);

	f1u = f1d = f2u = f2d = false;
}

//---- DEVICE::callback ------------------------------------------------------------------
//----        IDSIMCKT::setcallback
//----  ,    , , , 
//---- ,       ,
//----  IDSIMCKT::setcallback .
VOID i8080::callback (ABSTIME time, EVENTID eventid)
{
	inst->log("callback time: %d", time);
	if(eventid == 0x00)
	{
		PinBUSD->drivebusvalue(time, SW[7]);
//		PinBUSD->drivebusvalue(time+700000, 0x00);
//		ckt->setcallback(time + 100000, this, 0x02);
		PinBUSD->drivetristate(time+900000);
		PinDBIN->drivebool(time+1000000, 1);
		PinDBIN->drivebool(time+2200000, 0);
		PinWR->drivebool(time+500000, 0);
		PinWR->drivebool(time+900000, 1);
		PinWR->drivebool(time+2700000, 0);
		PinWR->drivebool(time+3000000, 1);
		PinHLDA->drivebool(time+900000, 0);
		PinHLDA->drivebool(time+1100000, 1);

		ckt->setcallback(time + 200000, this, 0x01);
	}

	if(eventid == 0x01)
	{
	}

}

void i8080::cpureset(ABSTIME time)
{
	cpu.BC = 0;
	cpu.DE = 0;
	cpu.HL = 0;
	cpu.PC = 0;
	cpu.SP = 0;
	cpu.A = 0;
	cpu.F = 0;
	cpu.Instruction = 0;

	CountT = 0;
//	RegPrint();
}

void i8080::RegPrint()
{/*
 PC:0x0000
 OPCODE: 0x0F
 INSTRUCTION: RRC
 SIZE: 1
 FLAGS: CY
 FUNCTIONS: A = A >> 1; bit 7 = prev bit 0; CY = prev bit 0
 
  A:0x00
 BC:0x0000
 DE:0x0000
 HL:0x0000
 
  F:0x00
  S Z x AC x P x C
  0 0 0 0  0 0 0 0
  
 SP:0x0000
*/
	CPURegWin.height = 20;
	CPURegWin.width = 70;
	CPURegWin.caption = "CPU";//" 58080";
	CPURegWin.type = PWT_STATUS;
	CPURegWin.id = 888;
	CPURegWin.flags = PWF_VISIBLE||PWF_AUTOREFRESH;
	pCPURegWin = (ISTATUSPOPUP *)inst->createpopup(&CPURegWin);

	UINT h = pCPURegWin->getcharheight();
	UINT w = pCPURegWin->getcharwidth();
uint8_t l=1;
	pCPURegWin->setcursorto(1*w, h*l);
	pCPURegWin->print(0, 0, RED, "PC:");
	pCPURegWin->setcursorto(4*w, h*l);
	pCPURegWin->print(0, 0, BLUE, "0x%04X", cpu.PC);
	l++;
	pCPURegWin->setcursorto(1*w, h*l);
	pCPURegWin->print(0, 0, RED, "Opcode:");
	pCPURegWin->setcursorto(8*w, h*l);
	pCPURegWin->print(0, 0, BLUE, "0x%02X", cpu.Instruction);
	l++;
	pCPURegWin->setcursorto(1*w, h*l);
	pCPURegWin->print(0, 0, RED, "Instruction:");
	pCPURegWin->setcursorto(13*w, h*l);
	pCPURegWin->print(0, 0, BLUE, "%s", opcodes[cpu.Instruction]);
	l++;
	pCPURegWin->setcursorto(1*w, h*l);
	pCPURegWin->print(0, 0, RED, "Size:");
	pCPURegWin->setcursorto(6*w, h*l);
	pCPURegWin->print(0, 0, BLUE, "%d", opcodesi[cpu.Instruction].Size);
	l++;
	pCPURegWin->setcursorto(1*w, h*l);
	pCPURegWin->print(0, 0, RED, "Flags:");
	pCPURegWin->setcursorto(7*w, h*l);
	pCPURegWin->print(0, 0, BLUE, "%s", opcodesi[cpu.Instruction].Flags);
	l++;
	pCPURegWin->setcursorto(1*w, h*l);
	pCPURegWin->print(0, 0, RED, "Functions:");
	pCPURegWin->setcursorto(12*w, h*l);
	pCPURegWin->print(0, 0, BLUE, "%s", opcodesi[cpu.Instruction].Functions);
	l+=2;
	pCPURegWin->setcursorto(w*2, h*l);
	pCPURegWin->print(0, 0, RED, "A:");
	pCPURegWin->setcursorto(w*4, h*l);
	pCPURegWin->print(0, 0, BLUE, "0x%02X", cpu.A);
	l++;
	pCPURegWin->setcursorto(w*1, h*l);
	pCPURegWin->print(0, 0, RED, "BC:");
	pCPURegWin->setcursorto(w*4, h*l);
	pCPURegWin->print(0, 0, BLUE, "0x%04X\n", cpu.BC);
	l++;
	pCPURegWin->setcursorto(w*1, h*l);
	pCPURegWin->print(0, 0, RED, "DE:");
	pCPURegWin->setcursorto(w*4, h*l);
	pCPURegWin->print(0, 0, BLUE, "0x%04X\n", cpu.DE);
	l++;
	pCPURegWin->setcursorto(w*1, h*l);
	pCPURegWin->print(0, 0, RED, "HL:");
	pCPURegWin->setcursorto(w*4, h*l);
	pCPURegWin->print(0, 0, BLUE, "0x%04X\n", cpu.HL);
	l+=2;
	pCPURegWin->setcursorto(w*2, h*l);
	pCPURegWin->print(0, 0, RED, "F:");
	pCPURegWin->setcursorto(w*4, h*l);
	pCPURegWin->print(0, 0, BLUE, "0x%02X", cpu.F);
	l++;
	pCPURegWin->setcursorto(w*2, h*l);
	pCPURegWin->print(0, 0, RED, "S Z x AC x P x C");
	l++;
	pCPURegWin->setcursorto(w*2, h*l);
	pCPURegWin->print(0, 0, BLUE, "%01X %01X %01X %01X  %01X %01X %01X %01X ", (cpu.F&0x80)!=0?1:0, (cpu.F&0x40)!=0?1:0, (cpu.F&0x20)!=0?1:0, (cpu.F&0x10)!=0?1:0, (cpu.F&0x08)!=0?1:0, (cpu.F&0x04)!=0?1:0, (cpu.F&0x02)!=0?1:0, (cpu.F&0x01)!=0?1:0);
	l+=2;
	pCPURegWin->setcursorto(w*1, h*l);
	pCPURegWin->print(0, 0, RED, "SP:");
	pCPURegWin->setcursorto(w*4, h*l);
	pCPURegWin->print(0, 0, BLUE, "0x%04X\n", cpu.SP);

}

void i8080::Simulate(ABSTIME time)
{
	if(f1u)
	{
		if(RDY)
		{
			if(CountT >= 3)
			{
				CountT = 0;
				cpu.PC++;
				if((Mode == 5)||(Mode == 6))
					ckt->suspend(inst, "end cycle");
			}
			else
			{
				CountT++;
			}
		}
	}
	M1();
}

void i8080::M1()
{
	if(f1u)
	{
		if(RDY)
		{
		}
		if((CountT==1)&&(RDY == 0))
			PinWAIT->drivebool(Time, 1);


		if(CountT==2)
		{
			PinWAIT->drivebool(Time, 0);
			cpu.Instruction = (uint8_t)PinBUSD->getbusvalue();
		}
		if(CountT==3)
		{
			PinWR->drivebool(Time, 1);
		}
	}
	if(f2u)
	{
		if(CountT==0)
		{
			PinSYNC->drivebool(Time+100000, 1);
			PinBUSA->drivebusvalue(Time+100000, cpu.PC);
			PinBUSD->drivebusvalue(Time+100000, SW[0]);
		}
		if(CountT==1)
		{
			PinSYNC->drivebool(Time+100000, 0);
			PinBUSD->drivetristate(Time+100000);
		}
		if(CountT==1)
		{
			PinDBIN->drivebool(Time+200000, 1);
		}
		if(CountT==2)
		{
			PinDBIN->drivebool(Time+100000, 0);
		}
		if(CountT==3)
		{
			PinBUSA->drivetristate(Time+100000);
		}
	}
}

void i8080::M2()
{
}

void i8080::M3()
{
}

void i8080::M4()
{
}

void i8080::M5()
{
}

void i8080::M6()
{
}

void i8080::M7()
{
}

void i8080::M8()
{
}

void i8080::M9()
{
}

void i8080::M10()
{
}

