#pragma once
#include "stdafx.h"
#include "stdint.h"
#include "vsm.hpp"
#include "vm80a.hpp"

static IINSTANCE *inst;
static IDSIMCKT *ckt;
static RUNMODES Mode;

class Ci8080A: ICPU
{
private:
public:
IINSTANCE *inst;
IDSIMCKT *ckt;
	LRESULT vdmhlr (VDM_COMMAND *cmd, BYTE *data);
	VOID loaddata (INT format, INT seg, ADDRESS address, BYTE *data, INT numbytes);
	VOID disassemble (ADDRESS address, INT numbytes);
	BOOL getvardata (VARITEM *vip, VARDATA *vdp);
};

class i8080 : public IDSIMMODEL
{
public:
i8080();
INT isdigital (CHAR *pinname);
VOID setup (IINSTANCE *inst, IDSIMCKT *dsim);
VOID runctrl (RUNMODES mode);
VOID actuate (REALTIME time, ACTIVESTATE newstate);
BOOL indicate (REALTIME time, ACTIVEDATA *data);
VOID simulate (ABSTIME time, DSIMMODES mode);
VOID callback (ABSTIME time, EVENTID eventid);

void cpureset(ABSTIME time);

private:
IINSTANCE *inst;
IDSIMCKT *ckt;
IDSIMPIN *PinC1;
IDSIMPIN *PinC2;
IDSIMPIN *PinRDY;
IDSIMPIN *PinHLT;
IDSIMPIN *PinINT;
IDSIMPIN *PinR;
IBUSPIN *PinBUSA;
IBUSPIN *PinBUSD;
IDSIMPIN *PinWAIT;
IDSIMPIN *PinHLDA;
IDSIMPIN *PinINTE;
IDSIMPIN *PinDBIN;
IDSIMPIN *PinWR;
IDSIMPIN *PinSYNC;

struct sCPUreg
{
	unsigned char Instruction;
	unsigned char A;
	unsigned char F;
	unsigned short BC;
	unsigned short DE;
	unsigned short HL;
	unsigned short PC;
	unsigned short SP;
}cpu;

VARITEM varitem;
VARDATA vardata;
ICPU *pCPU;

IDSIMCKT *pIDSIMCKT;

CREATEPOPUPSTRUCT IVARPOPUPs;
IVARPOPUP *pIVARPOPUP;

CREATEPOPUPSTRUCT ISOURCEPOPUPs;
ISOURCEPOPUP *pISOURCEPOPUP;

CREATEPOPUPSTRUCT CPUs;
VDM_COMMAND vdm_command;
//Ci8080A i8080A;
IVARPOPUP *pivarpopup;

CREATEPOPUPSTRUCT CPURegWin;
ISTATUSPOPUP *pCPURegWin;
void RegPrint(void);
int CCycles;

BOOL c1, c2;	//  
BOOL f1, f2, f1o, f2o, f1u, f1d, f2u, f2d;
BOOL RDY, HLT, INT, RES;

unsigned short data;
BOOL OldCState;
uint8_t SetupEn;

void Simulate(ABSTIME time);

uint8_t CountT;
ABSTIME Time;
void M1();
void M2();
void M3();
void M4();
void M5();
void M6();
void M7();
void M8();
void M9();
void M10();
CVM80A vm80a;

/*input*/		BOOL pin_clk;       // global module clock (no in original 8080)
/*input*/         BOOL pin_f1;        // clock phase 1 (used as clock enable)
/*input*/         BOOL pin_f2;        // clock phase 2 (used as clock enable)
/*input*/         BOOL pin_reset;     // module reset
/*output [15:0]*/  uint16_t pin_a;         // address bus /*output*/s
/*output [7:0]*/   uint8_t pin_dout;      // data bus /*output*/
/*input [7:0]*/   uint8_t pin_din;       // data bus /*input*/
/*output*/        BOOL pin_aena;      // address /*output*/s enable
/*output*/        BOOL pin_dena;      // data /*output*/s enable
/*input*/         BOOL pin_hold;      //
/*output*/        BOOL pin_hlda;      //
/*input*/         BOOL pin_ready;     //
/*output*/        BOOL pin_wait;      //
/*input*/         BOOL pin_int;       //
/*output*/        BOOL pin_inte;      //
/*output*/        BOOL pin_sync;      //
/*output*/        BOOL pin_dbin;      //
/*output*/        BOOL pin_wr_n;

};

#define InstructionFetch 0xA2
#define MemoryRead 0x82
#define MemoryWrite 0x00
#define StackRead 0x86
#define StackWrite 0x04
#define InputRead 0x42
#define OutputWrite 0x10
#define InterruptAcknowledge 0x23
#define HaltAcknowledge 0x8A
#define InterruptAcknowledgeWhileHalt 0x2B
const unsigned char SW[10] = {0xA2, 0x82, 0x00, 0x86, 0x04, 0x42, 0x10, 0x23, 0x8A, 0x2B};
