#include "stdafx.h"
#include "stdint.h"
#include "vsm.hpp"

#define gb(x,y) ((x&(1<<y))!=0?1:0)

class CVM80A
{
private:
public:
	CVM80A::CVM80A();
	void cycle(void);
	BOOL cmp(uint8_t i, uint8_t c, uint8_t m);

IDSIMPIN *PinC1;
IDSIMPIN *PinC2;
IDSIMPIN *PinRDY;
IDSIMPIN *PinHLT;
IDSIMPIN *PinINT;
IDSIMPIN *PinR;
IBUSPIN *PinBUSA;
IBUSPIN *PinBUSD;
IDSIMPIN *PinWAIT;
IDSIMPIN *PinHLDA;
IDSIMPIN *PinINTE;
IDSIMPIN *PinDBIN;
IDSIMPIN *PinWR;
IDSIMPIN *PinSYNC;
ABSTIME Time;

/*input*/		BOOL pin_clk;       // global module clock (no in original 8080)
/*input*/         BOOL pin_f1;        // clock phase 1 (used as clock enable)
/*input*/         BOOL pin_f2;        // clock phase 2 (used as clock enable)
/*input*/         BOOL pin_reset;     // module reset
/*output [15:0]*/  uint16_t *pin_a;         // address bus /*output*/s
/*output [7:0]*/   uint8_t *pin_dout;      // data bus /*output*/
/*input [7:0]*/   uint8_t pin_din;       // data bus /*input*/
/*output*/        BOOL *pin_aena;      // address /*output*/s enable
/*output*/        BOOL *pin_dena;      // data /*output*/s enable
/*input*/         BOOL pin_hold;      //
/*output*/        BOOL *pin_hlda;      //
/*input*/         BOOL pin_ready;     //
/*output*/        BOOL *pin_wait;      //
/*input*/         BOOL pin_int;       //
/*output*/        BOOL *pin_inte;      //
/*output*/        BOOL *pin_sync;      //
/*output*/        BOOL *pin_dbin;      //
/*output*/        BOOL *pin_wr_n;

//BOOL pin_aena, pin_dena;
//uint8_t pin_din, pin_dout;
//uint16_t pin_addr;
//BOOL f1_core, f2_core;

private:
	BOOL posedgeclk, posedgeclkn, posedgeold;
public:
	uint8_t d;
	uint8_t db, di;
	uint16_t a;
	BOOL clk, f1, f2;
	BOOL abufena, db_ena, db_stb, dbin_pin, dbinf2;
	BOOL reset;
	BOOL ready;
	BOOL dbin_ext;
	BOOL t851, t404, t382, t383, t712, t735, t773;
	BOOL hold, hlda_pin;
	BOOL hlda, h889;
	BOOL wr_n, t1124, t1011, sync;
	BOOL ready_int;
	uint16_t r16_pc, r16_hl, r16_de, r16_bc, r16_sp, r16_wz, mxo;
	uint16_t mxi;
	uint8_t mxr;
	BOOL mxwh, mxwl, mxrh, mxrl, mxw16, mxwadr;
	BOOL dec16, inc16, iad16;
	BOOL xchg_dh, xchg_tt, t3144;
	BOOL t1460, t1467, t1513, t1514, t1519;
	BOOL sy_inta, sy_wo_n, sy_hlta, sy_out, sy_m1, sy_inp, sy_memr;
	BOOL sy_stack;
	BOOL thalt, twt2;
	BOOL t1, t2, tw, t3, t4, t5;
	BOOL t1f1, t2f1, twf1, t3f1, t4f1, t5f1;
	BOOL m1, m2, m3, m4, m5;
	BOOL m1f1, m2f1, m3f1, m4f1, m5f1;
	BOOL start, ms0, ms1, m836, m839, m871;
	BOOL eom, t789, t887, t953, t976, t980;
	BOOL intr, inta, inte, mstart, minta;
	BOOL irq;
	uint8_t i;
	BOOL i25, i14, i03;
	BOOL imx, acc_sel;
	BOOL id_op, id_io, id_in, id_popsw, id_pupsw,
		id_nop, id_lxi, id_inx, id_inr, id_dcr, id_idr, id_mvi, id_dad,
		id_dcx, id_opa, id_idm, id_hlt, id_mov, id_opm, id_pop, id_rst,
		id_cxx, id_jxx, id_rxx, id_ret, id_jmp, id_opi, id_out, id_11x,
		id_rlc, id_rxc, id_rar, id_sha, id_daa, id_cma, id_stc, id_cmc,
		id_add, id_adc, id_sub, id_sbb, id_ana, id_xra, id_ora, id_cmp,
		id_lsax, id_mvim, id_shld, id_lhld, id_mvmr, id_mvrm, id_push,
		id_xthl, id_sphl, id_pchl, id_xchg, id_call, id_eidi, id_stlda;

	BOOL id80, id81, id82, id83, id84, id85, id86, id00, id01,
		id02, id03, id04, id05, id06, id07, id08, id09, id10;
	BOOL bgoto, jmpflag;
	BOOL jmptake, tree0, tree1, tree2;
	BOOL t2806, t2817, t2819, t3047, t2998, t3363, t3403, t3335, t3361;
	uint8_t xr, r, acc;
	uint8_t x, s, c;
	BOOL cl, ch, daa, daa_6x, daa_x6;
	BOOL a398;
	BOOL a327, a357, a358;
	BOOL alu_xout, alu_xwr, alu_xrd, alu_ald, alu_awr, alu_ard,
		alu_rld, alu_r00, alu_rwr, alu_srd, alu_zrd, alu_frd;
	BOOL psw_z, psw_s, psw_p, psw_c, psw_ac, tmp_c;
	BOOL t2222, t1375, t1497, t1698, t1668, t1780, t1993, t1994;
	BOOL psw_ld, psw_wr, t2046, t2133, t2175;
};