#include "windows.h"
//-------    PROSPICE.
#include "i8224.h" //-       .
//--- DEVICE::isdigital --------------------------------------------------------------
//---   ,  PROSPICE    
//---      . PROSPICE   IDSIMPIN  
//--- ,       ,   .
//---         IINSTANCE::getdsimpin.
//--- DSIM       DSIM.
//---         ,  ,
//---         .
//--- .    VSMSDK.HLP: Class IDSIMPIN
INT i8224::isdigital (CHAR *pinname)
{
	return 1;  //---     
	//---  :
	//---  1      .
	//---  0       .
	//--- -1     ,   ,    .
}

//--- DEVICE::setup ------------------------------------------------------------------
//---    PROSPICE   ,   
//---     .
//---          
//---   DSIM ,   .   -   ...
VOID i8224::setup (IINSTANCE *instance, IDSIMCKT *dsimckt)
{
	//------------------- IINSTANCE *instance -    ,
	//-------------------    .
	//----------------------------------------- IDSIMCKT *ckt -   DSIM ,
	//-----------------------------------------     .

	//--- ,       .
	inst = instance;
	ckt = dsimckt;

	//---       IINSTANCE::getdsimpin, 
	//---    ,     .
	//---       
	XTAL1 = inst->getdsimpin("XTAL1", true);
	XTAL2 = inst->getdsimpin("XTAL2", true);
	TANK = inst->getdsimpin("TANK", true);

	SYNC = inst->getdsimpin("SYNC", true);
	RESIN = inst->getdsimpin("RESIN", true);
	RDYIN = inst->getdsimpin("RDYIN", true);

	OSC = inst->getdsimpin("OSC", true);
	C1 = inst->getdsimpin("C1", true);
	C2 = inst->getdsimpin("C2", true);
	C = inst->getdsimpin("C", true);

	STB = inst->getdsimpin("$STB$", true);
	RES = inst->getdsimpin("RES", true);
	RDY = inst->getdsimpin("RDY", true);

	FREQUENCY = inst->getinitval("FREQUENCY", 10000000);
	if (FREQUENCY < 1000000)
		inst->message(" :%d", FREQUENCY);
	t = 500000000000 / FREQUENCY;
	OSC->setstate(SLO);
	C1->setstate(SLO);
	C2->setstate(SLO);
	C->setstate(SLO);

	STB->setstate(SHI);
	RES->setstate(SLO);
	RDY->setstate(SLO);

	count = 0;
	osc = 0;
	reset = 1;
	ready = 0;
	ststb = 0;
	c1 = 0;
	c2 = 0;


//	inst->message("STROB =%s", inst->getstrval("STROB", 0));
	//  Pin4 = inst->getdsimpin("/Q", true); //-- Pin3    "/Q"

	//---     :
	//  Pin4->setstate(SHI); //---"/Q"  "1": Strong High - SHI: Logic 1 active output.
	//---     ,     "Q"  "0"

	//---    : (.VSMSDK State Type)
	//---  Floating    FLT    Floating output - high-impedance.
	//---  Power High   PHI   Logic 1 power rail.
	//---  Power Low   PLO   Logic 0 power rail.   

	//---      :
	ckt->setcallback(t, this, 0x25);
	//---    ,   1  (,   )
	//---   ,        (callback)
	//---     (event) 0x25.
	//---       0x25   FFDEVICE::callback (time, eventid)
	//---   : if (eventid == 0x25){ ...  };
//	data = 0;
//	OldCState = false;
}

//---- DEVICE::runctrl ------------------------------------------------------------------
//----    PROSPICE        
//---- .      ,     
//----    ,      .
//----           
//----    (breakpoints).
//----         
//----   ,        .   
//----         , 
//----     .
//----
VOID i8224::runctrl (RUNMODES mode)
{
	//---     (RUNMODES mode):
	//---    RM_BATCH=-1,      // BATCH-    ;
	//---    RM_START,          //     () .
	//---    RM_STOP,         //   (  )
	//---    RM_SUSPEND,      //   (  );
	//---    RM_ANIMATE,      //   ;
	//---       :
	//---    RM_STEPTIME,      //  STEP()  
	//---    RM_STEPOVER,      //  "  "(Step Over command)
	//---    RM_STEPINTO,      //  "  " (Step Into command)
	//---    RM_STEPOUT,      //  "  "(Step Out command)
	//---    RM_STEPTO          //  "  "(Step To command)
	//---    ,     CPU  . 

	//---    VOID IINSTANCE::log (CHAR *msg, ...)  .
	//---     log- .
	//---           log-
	//---    ,         .
	//---   "printf"  C     [ ... ].
	//--- :
	//--- if (instance) instance->log ("DIGONLY::runctrl() called with mode=%d:%s", mode, EnumToRunCtrl(mode));

	//---         :
	//--- BOOL IINSTANCE::message (CHAR *msg, ...) -      ISIS.
	//---        .
	//---    "printf"  C     [ ... ].

	//---   , ,    ,  
	//---    log,    . (. Logging and messaging: )
}

//---- DEVICE::actuate ------------------------------------------------------------------
//----    PROSPICE      
//----   ,   .. (  ).
//----           
//----      ,  
//----       .
VOID i8224::actuate (REALTIME time, ACTIVESTATE newstate)
{
	//----   (ACTIVESTATE newstate)
}

//---- DEVICE::indicate ------------------------------------------------------------------
//----    PROSPICE     .  
//----          
//----     .
//----
BOOL i8224::indicate (REALTIME time, ACTIVEDATA *data)
{
	//----   (ACTIVEDATA *data)
	//----        (.VSMSDK.HLP).
	return FALSE;
}

//---- DEVICE::simulate ------------------------------------------------------------------
//----    DSIM         
//----      .
//----           ,
//----   IDSIMPIN      IDSIMPIN::setstate, 
//----       .
//----     ,    
//---- ,   IDSIMCKT::setcallback.
//----   (DSIMMODES = BOOT,     .   
//----    "simulate"   .)
VOID i8224::simulate (ABSTIME time, DSIMMODES mode)
{
	//---         (istate()),
	//---        (setstate()):
	//  Pin3->setstate(time, 1, Pin1->istate());
	//  Pin4->setstate(time, 1, Pin2->istate());
	//---      Pin1  Pin2,   1 "" 
	//---(1 )    (time)  
	//---       Pin3  Pin4.
	//---       , ,  
	//---    .  ,   
	//---   .   ,     
	//---   .
	resetin = ishigh(RESIN->istate());
//	RDY->drivebool(time, resetin);
/*	if (ishigh(C2->istate()))
	{
		reset = islow(RESIN->istate());
		RES->drivebool(time+1000, reset);
		RDY->drivebool(time+1000, ishigh(RDYIN->istate()));
	}*/

}

//---- DEVICE::callback ------------------------------------------------------------------
//----        IDSIMCKT::setcallback
//----  ,    , , , 
//---- ,       ,
//----  IDSIMCKT::setcallback .
VOID i8224::callback (ABSTIME time, EVENTID eventid)
{
	if(eventid == 0x25)
	{
		ckt->setcallback(time + t, this, 0x25);
		osc = !osc;

		if(!osc) count++;
		OSC->drivebool(time, osc);

		if(count == 1)
		{
			c1 = 1;
			C1->drivebool(time, 1);
		}
		if(count == 3)
		{
			c1 = 0;
			c2 = 1;
			C1->drivebool(time, 0);
			C2->drivebool(time, 1);
			C->drivebool(time, 1);
		}
		if(count == 8)
		{
			c2 = 0;
			C2->drivebool(time, 0);
			C->drivebool(time, 0);
		}
		if(count >= 10)
		{
			count = 0;
		}

		if (FrontC2.Front(c2, 1))
		{
			reset = islow(RESIN->istate());
			RES->drivebool(time+1000, reset);
			RDY->drivebool(time+1000, ishigh(RDYIN->istate()));
		}

		if((c1 && ishigh(SYNC->istate())) )
			STB->drivebool(time, 0);
		else
			STB->drivebool(time, 1);
	}
}
/*
VOID i8224::callback (ABSTIME time, EVENTID eventid)
{
	static int c = 0;
	if(eventid == 0x25)
	{
		ckt->setcallback(time + t*20, this, 0x25);
		C1->drivebool(time, 1);
		C1->drivebool(time + t*4, 0);
		C2->drivebool(time + t*4, 1);
		C2->drivebool(time + t*14, 0);

		if((ishigh(SYNC->istate())))
			STB->drivebool(time, 0);
		STB->drivebool(time+t*4, 1);
	}
}
*/
