//#include "windows.h"
//-------    PROSPICE.
#include "i8228.h" //-       .
//--- DEVICE::isdigital --------------------------------------------------------------
//---   ,  PROSPICE    
//---      . PROSPICE   IDSIMPIN  
//--- ,       ,   .
//---         IINSTANCE::getdsimpin.
//--- DSIM       DSIM.
//---         ,  ,
//---         .
//--- .    VSMSDK.HLP: Class IDSIMPIN
INT i8228::isdigital (CHAR *pinname)
{
	return 1;  //---     
	//---  :
	//---  1      .
	//---  0       .
	//--- -1     ,   ,    .
}

//--- DEVICE::setup ------------------------------------------------------------------
//---    PROSPICE   ,   
//---     .
//---          
//---   DSIM ,   .   -   ...
VOID i8228::setup (IINSTANCE *instance, IDSIMCKT *dsimckt)
{
	//------------------- IINSTANCE *instance -    ,
	//-------------------    .
	//----------------------------------------- IDSIMCKT *ckt -   DSIM ,
	//-----------------------------------------     .

	//--- ,       .
	inst = instance;
	ckt = dsimckt;

	//---       IINSTANCE::getdsimpin, 
	//---    ,     .
	//---       

	BUS_D = inst->getbuspin("D", 0, 8, true);
	BUS_DB = inst->getbuspin("DB", 0, 8, true);

	STB = inst->getdsimpin("$STB$", true);
	DBIN = inst->getdsimpin("DBIN", true);
	WR = inst->getdsimpin("$WR$", true);
	HLDA = inst->getdsimpin("HLDA", true);

	MEMR = inst->getdsimpin("$MEM_R$", true);
	MEMW = inst->getdsimpin("$MEM_W$", true);
	IOR = inst->getdsimpin("$I/O_R$", true);
	IOW = inst->getdsimpin("$I/O_W$", true);
	BUSEN = inst->getdsimpin("$BUSEN$", true);
	INTA = inst->getdsimpin("$INTA$", true);
/*
	int TPW = inst->gethexval("TPW", 0);
	int TDC = inst->gethexval("TDC", 0);
	int TRR = inst->gethexval("TRR", 0);
	int THD = inst->gethexval("THD", 0);
	int TWR = inst->gethexval("TWR", 0);
	int TE = inst->gethexval("TE", 0);

	BUS_DB->drivebusvalue(10, TPW);
	BUS_DB->drivebusvalue(20, TDC);
	BUS_DB->drivebusvalue(30, TRR);
	BUS_DB->drivebusvalue(40, THD);
	BUS_DB->drivebusvalue(50, TWR);
	BUS_DB->drivebusvalue(60, TE);
*/
	//	BUS_D->drivebusvalue(430000, 0xAA);
	//	BUS_D->drivetristate(470000);
	FrontSTSTB0.m_bStateOld = 1;
	FrontSTSTB1.m_bStateOld = 1;
	FrontWR0.m_bStateOld = 1;
	FrontWR1.m_bStateOld = 1;
	FrontDBIN0.m_bStateOld = 0;
	FrontDBIN1.m_bStateOld = 0;
	ststb = 1;
	wr = 1;
	busen = 1;
	dbin = 0;

	BUS_D->drivetristate(0);
	BUS_DB->drivetristate(0);
	//	ckt->setcallback(t, this, 0x00);
}

//---- DEVICE::runctrl ------------------------------------------------------------------
//----    PROSPICE        
//---- .      ,     
//----    ,      .
//----           
//----    (breakpoints).
//----         
//----   ,        .   
//----         , 
//----     .
//----
VOID i8228::runctrl (RUNMODES mode)
{
	//---     (RUNMODES mode):
	//---    RM_BATCH=-1,      // BATCH-    ;
	//---    RM_START,          //     () .
	//---    RM_STOP,         //   (  )
	//---    RM_SUSPEND,      //   (  );
	//---    RM_ANIMATE,      //   ;
	//---       :
	//---    RM_STEPTIME,      //  STEP()  
	//---    RM_STEPOVER,      //  "  "(Step Over command)
	//---    RM_STEPINTO,      //  "  " (Step Into command)
	//---    RM_STEPOUT,      //  "  "(Step Out command)
	//---    RM_STEPTO          //  "  "(Step To command)
	//---    ,     CPU  . 

	//---    VOID IINSTANCE::log (CHAR *msg, ...)  .
	//---     log- .
	//---           log-
	//---    ,         .
	//---   "printf"  C     [ ... ].
	//--- :
	//--- if (instance) instance->log ("DIGONLY::runctrl() called with mode=%d:%s", mode, EnumToRunCtrl(mode));

	//---         :
	//--- BOOL IINSTANCE::message (CHAR *msg, ...) -      ISIS.
	//---        .
	//---    "printf"  C     [ ... ].

	//---   , ,    ,  
	//---    log,    . (. Logging and messaging: )
}

//---- DEVICE::actuate ------------------------------------------------------------------
//----    PROSPICE      
//----   ,   .. (  ).
//----           
//----      ,  
//----       .
VOID i8228::actuate (REALTIME time, ACTIVESTATE newstate)
{
	//----   (ACTIVESTATE newstate)
}

//---- DEVICE::indicate ------------------------------------------------------------------
//----    PROSPICE     .  
//----          
//----     .
//----
BOOL i8228::indicate (REALTIME time, ACTIVEDATA *data)
{
	//----   (ACTIVEDATA *data)
	//----        (.VSMSDK.HLP).
	return FALSE;
}

//---- DEVICE::simulate ------------------------------------------------------------------
//----    DSIM         
//----      .
//----           ,
//----   IDSIMPIN      IDSIMPIN::setstate, 
//----       .
//----     ,    
//---- ,   IDSIMCKT::setcallback.
//----   (DSIMMODES = BOOT,     .   
//----    "simulate"   .)
VOID i8228::simulate (ABSTIME time, DSIMMODES mode)
{
	if (ststb == 1)
	{
		if(FrontSTSTB0.Front(islow(STB->istate()), 1))
		{
			ststb = 0;
			stbD = BUS_D->getbusvalue();
		}
	}
	if (ststb == 0)
	{
		if(FrontSTSTB0.Front(islow(STB->istate()), 0))
		{
			ststb = 1;
		}
	}

	if (dbin == 1)
	{
		if(FrontDBIN0.Front(islow(DBIN->istate()), 1))
		{
			dbin = 0;
		}
	}

	if (dbin == 0)
	{
		if(FrontDBIN1.Front(islow(DBIN->istate()), 0))
		{
			dbin = 1;
		}
	}

	if (wr == 1)
	{
		if(FrontWR0.Front(islow(WR->istate()), 1))
		{
			wr = 0;
		}
	}

	if (wr == 0)
	{
		if(FrontWR1.Front(islow(WR->istate()), 0))
		{
			wr = 1;
		}
	}

	if (busen == 1)
	{
		if(FrontBUSEN0.Front(islow(BUSEN->istate()), 1))
		{
			busen = 0;
		}
	}

	if (busen == 0)
	{
		if(FrontBUSEN1.Front(islow(BUSEN->istate()), 0))
		{
			busen = 1;
		}
	}

	if(dbin)
	{
		BUS_D->drivebusvalue(time, BUS_DB->getbusvalue());
	}
	else
	{
		BUS_D->drivetristate(time);
	}

	if(busen == 0)
	{
		BUS_DB->drivebusvalue(time, BUS_D->getbusvalue());
	}
	else
	{
		BUS_DB->drivetristate(time);
	}

	if (((stbD==SW[0])||(stbD==SW[1])||(stbD==SW[3]))&&(dbin == 1))
	{
		MEMR->drivebool(time, 0);
	}
	else
	{
		MEMR->drivetristate(time);
	}

	if (((stbD==SW[2])||(stbD==SW[4]))&&(wr == 0))
	{
		MEMW->drivebool(time, 0);
	}
	else
	{
		MEMW->drivetristate(time);
	}

	if (((stbD==SW[5])!=0)&&(dbin == 1))
	{
		IOR->drivebool(time, 0);
	}
	else
	{
		IOR->drivetristate(time);
	}

	if (((stbD==SW[6])!=0)&&(wr == 0))
	{
		IOW->drivebool(time, 0);
	}
	else
	{
		IOW->drivetristate(time);
	}

	if ((((stbD==SW[7])||(stbD==SW[9]))!=0)&&(dbin == 1))
	{
		INTA->drivebool(time, 0);
	}
	else
	{
		INTA->drivebool(time, 1);
	}
	if (FrontHLDA0.Front(ishigh(HLDA->istate()), 1))
	{
		INTA->drivebool(time, 1);
		IOR->drivetristate(time);
		MEMR->drivetristate(time);
	}
}

//---- DEVICE::callback ------------------------------------------------------------------
//----        IDSIMCKT::setcallback
//----  ,    , , , 
//---- ,       ,
//----  IDSIMCKT::setcallback .
VOID i8228::callback (ABSTIME time, EVENTID eventid)
{
}