#pragma once
#include "stdafx.h" // -      

class i8228 : public IDSIMMODEL
{
public:
	INT isdigital (CHAR *pinname);
	VOID setup (IINSTANCE *inst, IDSIMCKT *dsim);
	VOID runctrl (RUNMODES mode);
	VOID actuate (REALTIME time, ACTIVESTATE newstate);
	BOOL indicate (REALTIME time, ACTIVEDATA *data);
	VOID simulate (ABSTIME time, DSIMMODES mode);
	VOID callback (ABSTIME time, EVENTID eventid);
private:
	IINSTANCE *inst;
	IDSIMCKT *ckt;

	IBUSPIN *BUS_D;
	IBUSPIN *BUS_DB;

	IDSIMPIN *STB;
	IDSIMPIN *DBIN;
	IDSIMPIN *WR;
	IDSIMPIN *HLDA;

	IDSIMPIN *MEMR;
	IDSIMPIN *MEMW;
	IDSIMPIN *IOR;
	IDSIMPIN *IOW;
	IDSIMPIN *BUSEN;
	IDSIMPIN *INTA;

	int count;
	DWORD FREQUENCY;
	long long t;
	bool ststb, wr, busen, dbin;
	int stbD; // STB    STB
	CFront FrontSTSTB0;
	CFront FrontSTSTB1;
	CFront FrontWR0;
	CFront FrontWR1;
	CFront FrontBUSEN0;
	CFront FrontBUSEN1;
	CFront FrontDBIN0;
	CFront FrontDBIN1;
	CFront FrontHLDA0;

	int TPW;
	int TDC;
	int TRR;
	int THD;
	int TWR;
	int TE;
};

const unsigned char SW[10] = {0xA2, 0x82, 0x00, 0x86, 0x04, 0x42, 0x10, 0x23, 0x8A, 0x2B};
#define InstructionFetch 0xA2
#define MemoryRead 0x82
#define MemoryWrite 0x00
#define StackRead 0x86
#define StackWrite 0x04
#define InputRead 0x42
#define OutputWrite 0x10
#define InterruptAcknowledge 0x23
#define HaltAcknowledge 0x8A
#define InterruptAcknowledgeWhileHalt 0x2B
